.\" Copyright 1994 NEC Corporation, Tokyo, Japan.
.\" 
.\" Permission to use, copy, modify, distribute and sell this software
.\" and its documentation for any purpose is hereby granted without
.\" fee, provided that the above copyright notice appear in all copies
.\" and that both that copyright notice and this permission notice
.\" appear in supporting documentation, and that the name of NEC
.\" Corporation not be used in advertising or publicity pertaining to
.\" distribution of the software without specific, written prior
.\" permission.  NEC Corporation makes no representations about the
.\" suitability of this software for any purpose.  It is provided "as
.\" is" without express or implied warranty.
.\" 
.\" NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
.\" NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
.\" USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
.\" OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
.\" PERFORMANCE OF THIS SOFTWARE.

.\" $Id: ccustom.man,v 1.1.1.1 2002/10/19 08:27:30 aida_s Exp $
.TH CCUSTOM 1
.SH "NAME"
ccustom \- Customizing tool for Canna
.SH "SYNOPSIS"
.B "ccustom [filename]"
.SH "DESCRIPTION"
.PP
ccustom enables the setting and editing of initialize (customize) file 
to be conversational and simplified. 
.PP
If the initialize (customize) files exist when ccustom(1) starts, 
they are read automatically.  The priority of reading them is basically 
the following order: 
.IP (1) 4
file specified in the environmental variable CANNAFILE
.IP (2) 4
\&.canna under the home directory
.IP (3) 4
@(cannaLibDir)/default.canna
.PP
The reading is done also by directly specifying the initialize (customize)
file name in filename at start time.
.PP
Basic operations are as follows:  Use cursor keys to move the cursor.
Use the Return key for selection.  The ESC or 'q' key is available to
quit the menu.
.PP
The cursor moves responding to combination of a cursor key and the CTRL key.
It moves up, down, left, and right in response to pressing of 
CTRL+p, +n, +b, and +f, respectively.
.SH "MENU"
.IP "Read the customize file" 34
Enables an initialize (customize) file to be edited.
.IP "Retaining the result in the customize file" 34
Retains the result of editing (customizing) in a file.
.IP "Set the dictionary used" 34
Sets what Romaji-to-Kana table, 
system dictionary, Bushu conversion dictionary, 
and user dictionary are used.
.IP "Customize keys" 34
Customizes key operations.
.IP "Customize mode display character strings" 34
Sets the character strings displayed in each mode.
.IP "Customize other functions" 34
Sets the initial mode and On/Off options.
.IP "Quit" 34
Quits ccustom(1).  If you select ``Retention and quit''
at this time, the result
of editing (customizing) is retained in the last read file.  If you select
``Cancel'', you can continue the editing (customizing).  This function is 
useful when you erroneously select "Cancel".
