.\" Copyright 1994 NEC Corporation, Tokyo, Japan.
.\"
.\" Permission to use, copy, modify, distribute and sell this software
.\" and its documentation for any purpose is hereby granted without
.\" fee, provided that the above copyright notice appear in all copies
.\" and that both that copyright notice and this permission notice
.\" appear in supporting documentation, and that the name of NEC
.\" Corporation not be used in advertising or publicity pertaining to
.\" distribution of the software without specific, written prior
.\" permission.  NEC Corporation makes no representations about the
.\" suitability of this software for any purpose.  It is provided "as
.\" is" without express or implied warranty.
.\"
.\" NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
.\" NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
.\" USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
.\" OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
.\" PERFORMANCE OF THIS SOFTWARE.
.\"
.\" $Id: catdic.man,v 1.1.1.1 2002/10/19 08:27:33 aida_s Exp $
.TH CATDIC 1        
.SH "NAME"
catdic \- Download a dictionary
.SH "SYNOPSIS"
.B "catdic [{\-cs|\-cannaserver} \fIcanna-server\fP] [\-i|\-u \fIuser-name\fP] \fIremote-dic\fP [\-l \fIlocal-file\fP]"
.SH "DESCRIPTION"
.PP
catdic downloads a dictionary file to the current directory. 
The file downloaded is a dictionary file the dictionary name of which is
\fIremote-dic\fP.  It is in the user dictionary directory of the machine 
on which \fIcannaserver\fP(1M) is in operation.  (Hereafter, this machine 
is called the remote host.)
.SH "OPTIONS"
.IP "\-cs \fIcanna-server\fP (or \-cannaserver \fIcanna-server\fP)" 12
Specifies the name of the server machine that contains a dictionary to be 
downloaded.
.IP "\-i"
Downloads the system dictionary.
.IP "\-u \fIuser-name\fP"
Specifies the user name.  Another user's dictionary can be referenced by 
this user name.
.IP "\-l \fIlocal-file\fP"
\fIlocal-file\fP is the dictionary file name.  If it is omitted, the standard 
output will be assumed.
.SH "EXAMPLES"
.nf

  % catdic test
.fi
.PP
Outputs the contents of dictionary file ``test'' on the remote host, to the 
standard output.
.nf

  % catdic test \-l test2.t
.fi
.PP
Downloads dictionary file ``test'' on the remote host to current directory 
file ``test2.t''.
.SH "SEE ALSO"
.PP
cannaserver(1M), lsdic(1), mkdic(1)
