.\" Copyright 1994 NEC Corporation, Tokyo, Japan.
.\"
.\" Permission to use, copy, modify, distribute and sell this software
.\" and its documentation for any purpose is hereby granted without
.\" fee, provided that the above copyright notice appear in all copies
.\" and that both that copyright notice and this permission notice
.\" appear in supporting documentation, and that the name of NEC
.\" Corporation not be used in advertising or publicity pertaining to
.\" distribution of the software without specific, written prior
.\" permission.  NEC Corporation makes no representations about the
.\" suitability of this software for any purpose.  It is provided "as
.\" is" without express or implied warranty.
.\"
.\" NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN 
.\" NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
.\" USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR 
.\" OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
.\" PERFORMANCE OF THIS SOFTWARE. 
.\"
.\" $Id: RkCloseR.man,v 1.1.1.1 2002/10/19 08:27:47 aida_s Exp $ NEC;
.TH "RkCloseContext" "3"
.SH "NAME"
\f4RkCloseRoma\f1 / \f4RkwCloseRoma\f1 \- close the dictionary used for Romaji-kana conversion
.SH "SYNOPSIS"
.nf
.ft 4
#include <canna/RK.h>
RkCloseRoma(romaji)
struct RkRxDic *romaji;
RkwCloseRoma(romaji)
struct RkRxDic *romaji;
.ft 1
.fi
.SH "DESCRIPTION"
Romaji-kana conversion is effected by using a Romaji-kana conversion table created by \f2mkromdic(1)\f1.  \f2RkCloseRoma\f1 closes this Romaji-kana conversion table.  \f2romaji\f1 specifies the pointer to the Romaji-kana conversion table returned by \f2RkOpenRoma(3)\f1.
.P
\f2RkwCloseRoma\f1 is the similar function of \f2RkCloseRoma\f1.  This is provided just because of naming convention.
.SH "SEE ALSO"
.na
\f4RkOpenRoma\f1(3)
.ad
